<script lang="ts">
import { computed, defineComponent, reactive, ref, Ref } from '@vue/composition-api'
import { useState } from 'vuex-composition-helpers';
import ChipCounter from '@/components/ChipCounter.vue';
import time from "strftime";
import { colors, Order, FactoryState } from '@/model';
import { Socket } from 'socket.io-client';

export default defineComponent({
	components: { ChipCounter },
	props: {
		order: {
			type: Object,
			required: true
		},
		showQueueButton: {
			type: Boolean,
			default: false
		},
		disabled: {
			type: Boolean,
			default: false
		}
	},
	setup(props) {
		console.log(props.order)
		const o = reactive(Order.from(props.order as Order))
		const steps = ["Order placed", "Order active", "Delivered"];


		// console.log(o)
		let state = useState(["assemblyLineState"]).assemblyLineState as Ref<FactoryState>

		let assigned = computed(() => Object.assign({}, ...colors.map(color => ({ [color]: o.countAssigned(color) }))) as { [key: string]: number })
		// let assigned2 = computed(() => colors.reduce((dict, color) => {
		// 	dict[color] = o.value.countAssigned(color)
		// 	return dict
		// }, {} as {[key:string] : number}))


		let socket = useState(["socket"]).socket as Ref<Socket>;
		socket.value.on("chip-assigned", function (msg: Order) {
			if(msg.id == o.id)
				o.assignedChips = msg.assignedChips
		})

		let assignedChips = computed(() => o.assignedChips);


		let current_step = computed(() => {
			if(state.value.finishedOrders.some(x => x.id == o.id)) return 2;
			if(state.value.activeOrders.some(x => x.id == o.id)) return 1;
			return 0;
		})

		let date = o.date ? time('%Y-%m-%d %H:%M:%S', new Date(o.date.toString()) ) : ""

		return {
			o, assigned, assignedChips, steps, current_step, date
		}

	},
})
</script>

<template>
	<v-card class="card">
		<v-row justify="space-between">
			<v-col class="item" id="order_number">Order#{{ o.id }}</v-col>
			<v-col class="item" id="order_date">Placed {{ date }}</v-col>
		</v-row>
		<v-row justify="start">
			<v-col class="item" v-for="({color, amount}) of o.orderedItems" v-bind:key="color">
				<chip-counter :key="color + amount" 
				v-bind="assignedChips.length === 0 ? {color, amount} : {color, amount: assigned[color], max: amount }" 
				showCounter size="2rem"/>
			</v-col>
		</v-row>
		<div class="wrapper">
			<v-stepper alt-labels class="stepper_horizontal elevation-0 d-none d-md-block">
				<v-stepper-header>
					<template v-for="(step_name, index) in steps">
						<v-stepper-step
							:step="index+1"
							:complete=" current_step >= index"
							v-bind:key="step_name">
							{{ step_name }}
						</v-stepper-step>
						<v-divider
							v-if="index < steps.length - 1"
							v-bind:key="index"></v-divider>
					</template>
				</v-stepper-header>
			</v-stepper>
			<v-stepper vertical class="stepper_vertical elevation-0 d-md-none">
				<template v-for="(step_name, index) in steps">
					<v-stepper-step
						:step="index + 1"
						:complete="current_step >= index"
						:key="step_name">
						{{ step_name }}
					</v-stepper-step>
					<v-stepper-content
						:step="index + 1"
						v-if="index < steps.length - 1"
						v-bind:key="index">
					</v-stepper-content>
				</template>
			</v-stepper>
		</div>
	</v-card>
</template>

<style scoped>
#order_date {
	font-style: italic;
}
#order_number {
	font-size: large;
	font-weight: bold;
}
.card {
	margin: 1em;
	padding: 1em;
}
.chip_icon {
	border-radius: 50%;
	size: 2em;
}
.item {
	max-width: fit-content;
}
.wrapper {
	display: grid;
	grid-template-columns: min-content auto;
	grid-gap: 0.5em;
}
.stepper_vertical {
	grid-column: 1/3;
	grid-row: 1;
	padding: 0;
}
.button_change {
	grid-column: 1;
	grid-row: 2;
}
.button_cancel {
	grid-column: 1;
	grid-row: 3;
}
@media only screen and (min-width: 600px) {
	.wrapper {
		grid-template-rows: max-content min-content min-content min-content;
		grid-template-columns: auto min-content min-content;
		grid-gap: 0.5em;
	}
	.button_change {
		grid-column: 3;
		grid-row: 2;
	}
	.button_cancel {
		grid-column: 3;
		grid-row: 3;
	}
	.stepper_vertical {
		grid-column: 1;
		grid-row: 1/4;
	}
}

@media only screen and (min-width: 960px) {
	.wrapper {
		grid-template-rows: min-content min-content;
		grid-template-columns: auto min-content min-content;
		grid-gap: 0.5em;
	}
	.button_change {
		grid-column: 2;
		grid-row: 2;
	}
	.button_cancel {
		grid-column: 3;
		grid-row: 2;
	}
	.stepper_horizontal {
		grid-column: 1/4;
		grid-row: 1;
	}
}
</style>